/**
	Program to test read and write a pnm image 

	Input image must be in PGM format

	Fraga. May 24, 2002
**/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "matrix.h"
#include "pnm.h"

int main( int argc, char *argv[] )
{
	MATRIX *IMG;
	char namein[32];

	if ( argc < 2 ) { 
		fprintf( stderr, "Use: %s image.pgm\n", argv[0] );
		return -1;
	}

	strncpy( namein, argv[1], 32 );

	if ( (IMG = read_pnm( namein )) == NULL ) {
		fprintf( stderr, "ERROR: Reading!!!\n" );
		exit(1);
	}
	if ( write_pnm( IMG, "pru.pnm" ) != 0 ) {
		fprintf( stderr, "ERROR: Writing!!!\n" );
		exit(1);
	}

	
	fprintf( stderr, "OK!!!\n" );

	return 0;
}
